
From: "Andi Kleen" <ak@suse.de>

Hack to disable clustered mode on AMD systems

Make sure AMD big flat apic mode is not confused with clustered APIC 
mode. Ugly hack, but no better way found.

Signed-off-by: Andi Kleen <ak@suse.de>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/arch/x86_64/kernel/genapic.c |    7 +++++++
 1 files changed, 7 insertions(+)

diff -puN arch/x86_64/kernel/genapic.c~x86_64-hack-to-disable-clustered-mode-on-amd-systems arch/x86_64/kernel/genapic.c
--- 25/arch/x86_64/kernel/genapic.c~x86_64-hack-to-disable-clustered-mode-on-amd-systems	2005-01-09 23:01:14.249216896 -0800
+++ 25-akpm/arch/x86_64/kernel/genapic.c	2005-01-09 23:01:14.252216440 -0800
@@ -41,6 +41,12 @@ void __init clustered_apic_check(void)
 	u8 id;
 	u8 cluster_cnt[NUM_APIC_CLUSTERS];
 
+	if (boot_cpu_data.x86_vendor == X86_VENDOR_AMD) {
+		/* AMD always uses flat mode right now */
+		genapic = &apic_flat;
+		goto print;
+	}
+
 	memset(cluster_cnt, 0, sizeof(cluster_cnt));
 
 	for (i = 0; i < NR_CPUS; i++) {
@@ -71,6 +77,7 @@ void __init clustered_apic_check(void)
 	else
 		genapic = &apic_cluster;
 
+print:
 	printk(KERN_INFO "Setting APIC routing to %s\n", genapic->name);
 }
 
_
